//=============================================================================
//
//  CLASS AABBTree
//
//=============================================================================

#ifndef RAYTRACER_AABBTREE_H
#define RAYTRACER_AABBTREE_H

//== INCLUDES =================================================================
#include "Types.h"
#include "Surface.h"
#include "Accelerator.h"

//== CLASS DEFINITION =========================================================

/*!
	Uniform Grid.

*/
class AABBTree: public Accelerator
{
//-------------------------------------------------------------- constructors
public:
	//! standard constructor
	AABBTree( const SurfaceList *scene );

    // Destructor
    ~AABBTree();

//--------------------------------------------------------------- intersections

    bool intersect( const Ray&     clRay, 
	   			    const double  t0, 
				    const double  t1, 
					TracingContext&  tContext ) const;
					
};
//=============================================================================
#endif // RAYTRACER_AABBTree_H
//=============================================================================